"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class GenePanel(ProtocolElement):
    """
    A panel of genes
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "panelName",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        return {}

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import reports as reports_5_0_0

        return {
            "org.gel.models.report.avro.GenePanel": reports_5_0_0.GenePanel,
        }

    __slots__ = [
        "panelName",
        "panelVersion",
    ]

    def __init__(
        self,
        panelName,
        panelVersion=None,
        validate=None,
        **kwargs
    ):
        """Initialise the reports_5_0_0.GenePanel model.

        :param panelName:
            Panel name used from PanelApp
        :type panelName: str
        :param panelVersion:
            Panel version
        :type panelVersion: None | str
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "5.0.0"
